#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 Henrik Strunck
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#


"""
	Merge Sort
	Foliensatz: 02-Teile und Herrsche
	Ca. Folie(n): 4
"""
function merge_sort(A, p, r)
    # Sortiere A[p..r]
    if p < r
        q = (p + r) ÷ 2 # Ganzzahldivision
        merge_sort(A, p, q)
        merge_sort(A, q + 1, r)
        merge(A, p, q, r)
    end
end

function merge(A, p, q, r)
    # Sortiere A[p..r], nehme an, dass A[p..q] und A[q + 1..r] sortiert
    i = p
    j = q + 1
    B = fill(0, r - p + 1) # Hilfsfeld B
    for k = 1:(r - p + 1)
        if j > r || (i <= q && A[i] <= A[j])
            B[k] = A[i]
            i += 1
        else
            B[k] = A[j]
            j += 1
        end
    end
    for k = 1:(r - p + 1)
        A[k + p - 1] = B[k]
    end
end

# Beispielaufruf
A = [14, 42, 100, 56, 3, 8]
println("Eingabe: " * string(A))
merge_sort(A, 1, length(A))
println("Ausgabe: " * string(A))
