#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 Malte Luttermann
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Lampsort
	Foliensatz: 02-Teile und Herrsche
	Ca. Folie(n): 13
"""
function lampsort(A)
	agenda = []
	push!(agenda, [1, length(A)])
	while !isempty(agenda)
		i, j = pop!(agenda)
		if i < j
			p = partition(A, i, j)
			push!(agenda, [i, p-1])
			push!(agenda, [p+1, j])
		end
	end
end

function partition(A, i, j)
	x = A[j] # Es muss das letzte sein, damit der Code funktioniert.
	b = i - 1
	for k = i:j
		# swap A[k] and A[b+1]
		temp = A[k]
		A[k] = A[b+1]
		A[b+1] = temp
		if A[b+1] <= x
			b = b + 1
		end
	end
	return b
end

# Beispielaufruf
A = [4, 7, 3, 5, 9, 1]
println("Eingabe: " * string(A))
lampsort(A)
println("Ausgabe: " * string(A))