#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 Henrik Strunck
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#


"""
	Heap Sort
	Foliensatz: 02-Teile und Herrsche
	Ca. Folie(n): 34-39
"""
function heap_sort(A)
    lastnode = length(A)
    make_heap(A, lastnode)
    root = 1
    while lastnode != root
        temp = A[root]
        A[root] = A[lastnode]
        A[lastnode] = temp
        lastnode -= 1
        heapify(A, root, lastnode)
    end
end

function make_heap(A, n)
    p = parent(n)
    root = 1
    for v = p:-1:root
        heapify(A, v, n)
    end
end

function heapify(A, k, lastnode) # k is currently considered node
    if !is_leaf(A, k, lastnode) 
        left = left_child(k)
        right = right_child(k)
        maxc = left
        # determine the biggest child
        if exists(A, right, lastnode) && A[right] > A[left]
            maxc = right
        end
        if A[maxc] > A[k]
            # swap key of maxc and k
            temp = A[maxc]
            A[maxc] = A[k]
            A[k] = temp
            heapify(A, maxc, lastnode)
        end
    end
end

function left_child(v)
    return 2 * v
end

function right_child(v)
    return 2 * v + 1
end

function parent(v)
    return v ÷ 2
end

function exists(A, v, lastnode)
    return v <= length(A) && v <= lastnode
end

function is_leaf(A, v, lastnode)
    return 2 * v > lastnode
end

# Beispielaufruf
A = [14, 42, 100, 56, 3, 8]
println("Eingabe: " * string(A))
heap_sort(A)
println("Ausgabe: " * string(A))
