#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Counting Sort
	Foliensatz: 03-Sortierung-durch-Verteilen
	Ca. Folie(n): 8, 10-30
"""
function counting_sort(A)
	@assert minimum(A) >= 1 # funktoniert nur bei ausschliesslich postiven Zahlen

	k = maximum(A)
	n = length(A)

	# 1. Initialisiere
	C = fill(0, k)
	for i = 1:k
		C[i] = 0
	end

	# 2. Zaehle
	for j = 1:n	
		C[A[j]] = C[A[j]] + 1
	end

	# 3. Bestimme Summe
	for i = 2:k
		C[i] = C[i] + C[i - 1]
	end

	# 4. Ordne neu
	B = fill(0, n)
	for j = n:-1:1
		B[C[A[j]]] = A[j]
		C[A[j]] = C[A[j]] - 1
	end

	return B
end


# Beispielaufruf
A = [4, 7, 3, 5, 9, 1]
println("Eingabe: " * string(A))
B = counting_sort(A)
println("Ausgabe: " * string(B))