#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Stack/ Kellerspeicher
		Realisierung eines Datentyps mit den Operationen von den Folien.
		Fuer eine schnelle Implementierung sollte man *immer* die Julia-eigenen Datentypen nutzen!

	Foliensatz: 03-Sortierung durch Verteilen
	Ca. Folie(n): 66
"""

# Datentypen
mutable struct StackElement 
	first :: Any
	rest :: Union{StackElement, Nothing}
end

mutable struct Stack 
	internal_repr :: Union{StackElement, Nothing}
end

# Funktionen
function make_stack()
	return Stack(nothing)
end

function push(e, s)
	s.internal_repr = StackElement(e, s.internal_repr)
	nothing
end

function top(s)
	if isnothing(s.internal_repr)
		throw(BoundsError(s, 1))
	else 
		return s.internal_repr.first
	end
end

function pop(s)
	if isnothing(s.internal_repr)
		throw(BoundsError(s, 1))
	else 
		v = s.internal_repr.first
		s.internal_repr = s.internal_repr.rest
		return v
	end
end

function empty_stack(s)
	return isnothing(s.internal_repr)
end



# Beispielaufrufe
# 	Stack erstellen 
my_stack = make_stack()
#	Ist leer 
println(empty_stack(my_stack))
#	Etwas drauflegen
push("H", my_stack)
push("A", my_stack)
push("L", my_stack)
println(empty_stack(my_stack))
println(my_stack)

# Element runternehmen
println(top(my_stack))
println(pop(my_stack))
println(top(my_stack))

