#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Queue/ Schlange
		Realisierung eines Datentyps mit den Operationen von den Folien.
		Fuer eine schnelle Implementierung sollte man *immer* die Julia-eigenen Datentypen nutzen!

	Foliensatz: 03-Sortierung durch Verteilen
	Ca. Folie(n): 70
"""

# Datentypen
mutable struct QueueElement 
	value :: Any
	next :: Union{QueueElement, Nothing}
end

mutable struct Queue 
	internal_repr :: Union{QueueElement, Nothing}
	last :: Union{QueueElement, Nothing}
end

# Funktionen
function make_queue()
	return Queue(nothing, nothing)
end

function enqueue(e, q)
	new = QueueElement(e, nothing)
	if isnothing(q.internal_repr)
		q.internal_repr = new
	else 
		q.last.next = new
	end
	q.last = new 
	nothing
end

function next(q)
	return q.internal_repr.value
end

function dequeue(q)
	v = q.internal_repr.value
	q.internal_repr = q.internal_repr.next
	if isnothing(q.internal_repr)
		q.last = nothing
	end
	return v
end

function empty_queue(q)
	return isnothing(q.internal_repr)
end

# Beispielaufrufe
my_queue = make_queue()
#	Ist leer 
println(empty_queue(my_queue))
#	Elemente einfuegen
enqueue("A", my_queue)
enqueue("B", my_queue)
enqueue("C", my_queue)
enqueue("D", my_queue)
println(empty_queue(my_queue))
println(my_queue)

# Elemente runternehmen 
println(next(my_queue), ' ', dequeue(my_queue))
println(dequeue(my_queue))
println(dequeue(my_queue))
println(dequeue(my_queue))
println(my_queue)