#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Bucket Sort
	Foliensatz: 03-Sortierung-durch-Verteilen
	Ca. Folie(n): 73
"""
function bucket_sort(A, waehle_eimer)
	@assert minimum(A) >= 1 # funktoniert nur bei ausschliesslich postiven Zahlen

	k = waehle_eimer(maximum(A))

	# leere Eimer erstellen
	E = []
	for i = 1:k
		insert!(E, i, [])
	end
	
	# in die Eimer aufteilen
	for i = 1:length(A) 
		push!(E[waehle_eimer(A[i])], A[i])
	end

	# Eimer sortieren
	for i = 1:k 
		sort!(E[i])
	end

	# Eimer zusammenfuegen
	B = Int[]
	for i = 1:k
		append!(B, E[i])
	end
	return B	
end

""" 
	Zuordnung der Werte auf Eimer auf Basis der Zehner.
	Also, 1 in Eimer 1 und 12 in Eimer 2, ...
"""
function eimer_nach_zehner(n)
	return n ÷ 10 + 1
end

# Beispielaufrufe
A = [40, 44, 70, 35, 34, 12, 11, 1]
println("Eingabe: " * string(A))
B = bucket_sort(A, eimer_nach_zehner)
println("Ausgabe: " * string(B))

A = [4,2,1,3,2,1,3,2,1,2,3,2,1,4]
println("Eingabe: " * string(A))
B = bucket_sort(A, identity)
println("Ausgabe: " * string(B))

A = [40,20,10,30,20,10,30,20,10,20,30,20,10,40]
println("Eingabe: " * string(A))
B = bucket_sort(A, (x)->x÷10)
println("Ausgabe: " * string(B))

A = [41,22,17,33,25,11,38,20,19,22,31,24,16,42]
println("Eingabe: " * string(A))
B = bucket_sort(A, (x)->x÷10)
println("Ausgabe: " * string(B))
