#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 Malte Luttermann
 Henrik Strunck
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

# Im Algorithmus werden zufaellige Werte gewaehlt. Damit der Programmablauf
# dabei trotzdem reproduzierbar ist, setzen wir ein sogenanntes "Seed" ein.
# Damit erzeugt der Zufallsgenerator von Julia immer die gleichen Zufallswerte
# fuer eine gleiche Folge von Aufrufen.
using Random
Random.seed!(1234)

"""
	Quickselect
	Foliensatz: 05-Selektion
	Ca. Folie(n): 6
"""
function quickselect(A, l, r, k)
    # a[l..r]: Restfeld, k: k-kleinstes Element, l≤k≤r
    if r == l
        return A[l]
    end
    z = rand(l:r)
	A[z], A[r] = A[r], A[z] # tausche Elemente an Position z und r
    v = A[r]
    i = l
    j = r
    while true # ordne Elemente in [l, r - 1] nach Pivot v
        while A[i] < v
            i += 1
        end
        while A[j] >= v && j != l
            j -= 1
        end
        if i < j
			A[i], A[j] = A[j], A[i]
        end 
        if j <= i
            break
        end
    end
	A[i], A[r] = A[r], A[i]
    if k < i
        return quickselect(A, l, i - 1, k)
    elseif k > i
        return quickselect(A, i + 1, r, k)
    else
        return A[k]
    end
end

# Beispielaufruf
A = [14, 42, 100, 56, 3, 8]
println("Eingabe: " * string(A))
k_smallest_elem = quickselect(A, 1, length(A), 2)
println("Ausgabe: " * string(k_smallest_elem))
