#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Malte Luttermann
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Gierige Restaurant-Platzierung

	Foliensatz: 12-Dynamische-Programmierung-Greedy-Verfahren
	Ca. ab Folie(n): 73
"""

function greedy_locate(towns, min_dist)
	selected_towns = [towns[1]]
	n = length(towns)
	d = 0
	for i = 2:n
		d = d + dist(towns[i-1], towns[i])
		if d >= min_dist
			push!(selected_towns, towns[i])
			d = 0
		end
	end

	return selected_towns
end

function dist(t1, t2)
	# Assumes that t2 comes after t1
	return t2[2]
end

# Beispielaufrufe
# 	Staedte haben uniformen Profit (d.h. alle haben denselben Profit).
# 	Daher ist nur die Distanz relevant und Staedte werden als Tupel
# 	(Nummer, Distanz zu vorheriger Stadt) angegeben.
towns = [
	(1, 0), (2, 5), (3, 2), (4, 2), (5, 6),
	(6, 6), (7, 3), (8, 6), (9, 10), (10, 7)
]
selected_towns = greedy_locate(towns, 10)
for (t, _) in selected_towns
	println("Waehle Stadt $t")
end