#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Henrik Strunck
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Brute-Force-Suche
		Algorithmus zum Suchen eines Musters in einem Text. 

	Foliensatz: 13-Zeichenkettenabgleich
	Ca. ab Folie(n): 6
"""

function bf_search(t :: String, p :: String) :: Int
	n = length(t)
	m = length(p)
	for i = 1:(n - m) + 1
		j = 0
		while j < m && t[i + j] == p[j + 1] # passende Teilkette
			j += 1
		end
		if j == m
			return i # erfolgreiche Suche
		end
	end
	return -1 # erfolglose Suche
end


# Beispielaufrufe
text = "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, \
		sed diam nonumy eirmod tempor invidunt ut labore et dolore magna \
		aliquyam erat, sed diam voluptua. At vero eos et accusam et justo \
		duo dolores et ea rebum."
pattern = "z"
println("bf_search(\"", text, "\", \"", pattern, "\")")
position = bf_search(text, pattern)
println(position > 0 ? "Muster gefunden an Stelle " * string(position) : "Muster nicht vorhanden", ".")
println("")
pattern = "ip"
println("bf_search(\"", text, "\", \"", pattern, "\")")
position = bf_search(text, pattern)
println(position > 0 ? "Muster gefunden an Stelle " * string(position) : "Muster nicht vorhanden", ".")
