#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Henrik Strunck
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Rabin-Karp
		Algorithmus zum Suchen eines Musters in einem Text.

	Foliensatz: 13-Zeichenkettenabgleich
	Ca. ab Folie(n): 30
"""

function rk_search(t :: String, p :: String, hf :: Function = hash) :: Int
	n = length(t)
	m = length(p)
	h_p = hf(p)
	for i = 1:(n - m) + 1
		h = hf(t[i:i + m - 1])
		if h == h_p
			if t[i:i + m - 1] == p
				return i # erfolgreiche Suche
			end
		end
	end
	return -1 # erfolglose Suche
end


# Beispielaufrufe
text = "Lorem ipsum dolor sit amet, consetetur sadipscing elitr, \
		sed diam nonumy eirmod tempor invidunt ut labore et dolore magna \
		aliquyam erat, sed diam voluptua. At vero eos et accusam et justo \
		duo dolores et ea rebum."
pattern = "z"
println("rk_search(\"", text, "\", \"", pattern, "\")")
position = rk_search(text, pattern)
println(position > 0 ? "Muster gefunden an Stelle " * string(position) : "Muster nicht vorhanden", ".")
println("")
pattern = "ip"
println("rk_search(\"", text, "\", \"", pattern, "\")")
position = rk_search(text, pattern)
println(position > 0 ? "Muster gefunden an Stelle " * string(position) : "Muster nicht vorhanden", ".")
