#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Suche in Suffix-Feldern

	Foliensatz: 13-Zeichenkettenabgleich
	Ca. ab Folie(n): 51
"""

function find(p::String, A::Vector{String}, positions::Vector{Int})
	# Suchzeichenkette p, Suffix-Feld A, Positionen positions
	# liefert Position von p oder -1, falls p nicht in Zeichenkette

	l = 1
	r = length(A)
	n = length(p)
	while l < r
		m = ceil(Int, (l+r) / 2)
		if p == A[m][begin:minimum((n, end))]
			return positions[m]
		elseif p < A[m][begin:minimum((n, end))]
			r = m
		else 
			l = m
		end
	end

	return -1
end

# Beispielaufruf
#	Analog zu den Folien, ab 46
#	suche "sip" in "mississippi"
suffix_array = [
	"i",
	"ippi",
	"issippi",
	"ississippi",
	"mississippi",
	"pi",
	"ppi",
	"sippi",
	"sissippi",
	"ssippi",
	"ssissippi"
]
positions = [
	10,
	7,
	4, 
	1,
	0,
	9,
	8,
	6, 
	3,
	5,
	2
]
pos = find("sip", suffix_array, positions)
print("\"sip\" beginnt in \"mississippi\" an Position: $pos")
