#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	List-Scheduling

	Foliensatz: 16-Approximation
	Ca. ab Folie(n): 5
"""

# Anzahl Maschinen m, Anzahl Jobs n, Laufzeiten von Jobs t (1 <= i <= n, t[i])
function list_scheduling(m::Int, n::Int, t::Vector{Int})
	L = Vector{Int}(undef, m)
	J = Vector{Vector{Int}}(undef, m)
	for i = 1:m 
		L[i] = 0
		J[i] = Int[]
	end

	for j = 1:n
		_, i = findmin(L) 	# Mit Prioritaetswarteschlange umsetzen
		push!(J[i], j)		# Job planen 
		L[i] = L[i] + t[j]	# Last der Maschine anpassen
	end
	return J, L
end

# Beispielaufrufe
schedule, durations = list_scheduling(3, 10, [1, 1, 1, 20, 10, 7, 8, 12, 2, 12])
for (i, (d, s)) in enumerate(zip(durations, schedule))
	println("Maschine $i:\t Jobs $(join(s, ", "))\t (Dauer: $d) ")
end