#=
 Uebung zur Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Weekly Julia 

		Die Idee hinter diesen "Codeschnipseln" ist jede
		Woche in der Uebung auf den Praesenzblaettern
		aktuell relevante oder neue Julia-Syntax
		zu wiederholen. 
"""

# 1 a)
for i = 1:1:10
	println(i)
end

# 1 b)
for i = 10:-1:1
	println(i)
end

# 1 c)
A = 12
B = 13
C, D = 14, 15
print(A, " ", B, " ", C, " ", D)

A, B = B, A
print(A, " ", B, " ", C, " ", D)

# 2 a)
function hello(name="Erna")
	println("Hello $name, nice to meet you!")
end
hello()
hello("Otto")

# 2 b)
function return_value1()
	return ":)"
end
println(return_value1())

# 2 c)
function return_value2()
	":)"
end
println(return_value2())

# 3 a)
println("One" * "Two")
println("One", "Two")
println(string(1, 2))

# 3 b)
A = [1, 2, 3]
println(A, " of type ", typeof(A))
println("length = ", length(A))
println("maximum = ", maximum(A))

# 3 c)
A = fill("Wert", 5)
println(A)

B = [i^2 for i = 1:5]
println(B)

C = Array{Int}(undef, (2,2))
C[1,2] = 12
println(C)

# 3 d)
D = [1,2,3,4,5,6]
for i in D
	println(i, " ", i*2)
end

println(D[2:3])
println(D[2:end])
println(D[begin:3])

# 3 e)
A = []
push!(A, 2)
insert!(A, 1, 1)
push!(A, 3)

println(A)

# 4 a)
struct Datentyp 
	attribut_1
	attribut_2
end
D = Datentyp(1,"Hallo")
println(D.attribut_2)

# 4 b)
try
	D.attribut_2 = 12
catch e 
	println(e)
end

# 4 c)
mutable struct Datentyp2
	attribut_1
	attribut_2
end
D2 = Datentyp2(1,"Hallo")
D2.attribut_2 = "Tschuess"
println(D2)

# 5 a)
power = function (x, e=2)
	return x^e
end
println(power(2), " ", power(2, 3))

# 5 b)
P1 = map(power, [1,2,3,4,5])
P2 = map((x) -> x^2, [1,2,3,4,5])
println(P1, P2)

println(reduce(+, P1, init=0))

# 6 a)
function combine(i::Int, j::Int)
	return i + j
end
function combine(s::String, t::String)
	return s * t 
end

println(combine(1, 2))
println(combine("A", "B"))
try 
	println(combine(1, "A"))
catch e 
	println(e)
end


# 6 b)
function combine2(i::Union{String, Int}, j::Union{String, Int})
	s = string(i)
	t = string(j)
	return s * t 
end
println(combine2(1, "A"))
try
	println(combine2(true, "A"))
catch e 
	println(e)
end

# 7 a) 
struct Example
	name :: String 
	values :: Array{Int}
end 
E = Example("Test1", [2,4,6,8])

# 7 b)
function Base.show(io::IO, e::Example)
	print(io, "$(e.name) mit den Werten: ", e.values)
end 
println(E)
E

# 7 c)
function Base.length(e::Example)
	return length(e.values)
end 

# 7 d)
function Base.iterate(e::Example, index::Int=1) 
	if index <= length(e)
		return e.values[index], index+1
	else 
		return nothing
	end
end

for value in E
	println(value)
end

element_state = iterate(E)
while !isnothing(element_state)
	(element, state) = element_state
	print(element, ", ")
	global element_state = iterate(E, state)
end

# 8 a)
for (i, s) in enumerate(["A", "B", "C"])
	println(i, ":", s)
end

for (i, j) in zip([1, 2, 3, 4], ['A', 'B', 'C', 'D'])
	println("i=$i, j=$j")
end

# 9 a)
mutable struct Node
	value :: Any 
	parent :: Union{Nothing, Node} 
	left_children :: Union{Nothing, Node} 
	right_children :: Union{Nothing, Node} 

	Node(e) = new(e, nothing, nothing, nothing)
end

N = Node(1)
println(N)
N.parent = Node(2)
println(N)

try
	# Diesen Konstruktor gibt es nicht, da nur Node(e) oben definiert ist!
	Node(12, nothing, nothing, nothing)
catch e 
	println(e)
end

# 10 
b = 12
println(typeof(b))

t = (1, 2)
println(typeof(t))

p = "Hallo" => 12
typeof(p)
println(p.first, p.second)

s = "HuHu"
let
	s::String = "zeichenkette"
	println(s)
end
println(s)

# 10a
let
	c::Char = 'A'
	c = 'C'
end

let
	c::Char = 'A'
	c = 'C'
	try 
		c = "Hallo" 
	catch e 
		println(e)
	end
end

let
	u::Union{String, Int} = "Hallo"
	u = 10
	try 
		u = 1.2
	catch e 
		println(e)
	end
end

# 11 a
# => see weekly-julia-graphs.jl

# 12
module MyModule

	function my_function() 
		print("MyModule my_function()")
	end

	function other_function() 
		print("MyModule other_function()")
	end

	export my_function
end

println(MyModule.my_function())
println(MyModule.other_function())

using .MyModule 

println(my_function())
try
	other_function()
catch e 
	println(e)
end