#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 Malte Luttermann
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Queue/ Warteschlange fuer die weitere Nutzung, z.B. in der Breitensuche.

	Zum Anschauen der Implementierung bitte in "03-*/e-queue.jl" gucken.

	> Hier bitte nichts aendern, damit der aufbauende Code keine Fehler verursacht!
"""

# Datentypen
mutable struct QueueElement 
	value :: Any
	next :: Union{QueueElement, Nothing}
end

mutable struct Queue 
	first :: Union{QueueElement, Nothing}
	last :: Union{QueueElement, Nothing}
end

# Funktionen
function make_queue()::Queue
	return Queue(nothing, nothing)
end

function make_queue(elements)::Queue
	q = make_queue()
	for e in elements
		enqueue(e, q)
	end
	return q
end

function enqueue(e, q::Queue)
	new = QueueElement(e, nothing)
	if isnothing(q.first)
		q.first = new
	else 
		q.last.next = new
	end
	q.last = new 
	nothing
end

function next(q::Queue)
	return q.first.value
end

function dequeue(q::Queue)
	v = q.first.value
	q.first = q.first.next
	if isnothing(q.first)
		q.last = nothing
	end
	return v
end

function empty_queue(q::Queue)
	return isnothing(q.first)
end

function Base.show(io::IO, q::QueueElement)
	print(io, q.value)
end

function Base.show(io::IO, q::Queue)
	print(io, "Queue: ")
	if empty_queue(q)
		print(io, "empty")
	end

	curr = q.first
	while !isnothing(curr)
		print(io, curr, " -> ")
		curr = curr.next
	end
	print(io, "nothing")
end