#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Magnus Bender
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	Stack/ Kellerspeicher fuer die weitere Nutzung, z.B. zur Ermittlung von
	kuerzesten Wegen in DAGs mittels topologischer Sortierung.

	Zum Anschauen der Implementierung bitte in "03-*/d-stack.jl" gucken.

	> Hier bitte nichts aendern, damit der aufbauende Code keine Fehler verursacht!
"""

# Datentypen
mutable struct StackElement 
	value :: Any
	next :: Union{StackElement, Nothing}
end

mutable struct Stack 
	top :: Union{StackElement, Nothing}
end

# Funktionen
function make_stack()::Stack
	return Stack(nothing)
end

function push(e, s::Stack)
	s.top = StackElement(e, s.top)
	nothing
end

function top(s::Stack)
	if isnothing(s.top)
		throw(BoundsError(s, 1))
	else 
		return s.top.value
	end
end

function pop(s::Stack)
	if isnothing(s.top)
		throw(BoundsError(s, 1))
	else 
		v = s.top.value
		s.top = s.top.next
		return v
	end
end

function empty_stack(s::Stack)::Bool
	return isnothing(s.top)
end

function Base.in(e, s::Stack)
	v = s.top
	while !isnothing(v)
		if v.value == e 
			return true 
		end 
		v = v.next
	end 
	return false
end

function Base.show(io::IO, s::Stack)
	v = s.top
	str = " -> "
	while !isnothing(v)
		str *= string(v.value) * " -> "
		v = v.next
	end 
	print(io, str[begin:end-4], "]")
end