#=
 Vorlesung
	Algorithmen und Datenstrukturen
	Prof. Dr. Ralf Moeller
	Institut fuer Informationssysteme, Universitaet zu Luebeck
	https://www.ifis.uni-luebeck.de

 Malte Luttermann
 (c) 2022 - 2023, GPLv3 gnu.org/licenses/gpl-3.0.txt
=#

"""
	0-indiziertes Array fuer die Nutzung bei dynamischer Programmierung.

	> Hier bitte nichts aendern, damit der aufbauende Code keine Fehler verursacht!
"""

struct ZeroIndexArray{T,N} <: AbstractArray{T,N}
	internal_repr::Array{T,N}
end
ZeroIndexArray{T}(init, dims...) where T = ZeroIndexArray(Array{T}(init, dims...))
Base.getindex(arr::ZeroIndexArray, vals...) = arr.internal_repr[map(v -> v+1, vals)...]
Base.setindex!(arr::ZeroIndexArray, val, idxs...) = arr.internal_repr[map(i -> i+1, idxs)...] = val
Base.size(arr::ZeroIndexArray, dim::Int) = size(arr.internal_repr, dim)
Base.show(io::IO, arr::ZeroIndexArray) = show(io, arr.internal_repr)